
FMDIR="/root/firmware_update"
DSTDIR1="/root"
DSTDIR2="/mnt"
ISWAIT="false"

RBF="DE10_LITE_SDRAM_Nios_Test.rbf.inv"

FILE_UPDATE="firmware_update.tar.gz"

killall wait_print > /dev/null 2>&1

if ! [ -f /tmp/wait_print ]; then
	cp /root/wait_print /tmp
fi


V1=$(cat .profile | grep -c '-channels 1')

if [ $V1 == '1' ]; then
	echo "SFP-1E1-ToP"
	FILE_UPDATE="firmware_update_sfp_1E1_top"
fi

V1=$(cat .profile | grep -c '-channels 2')

if [ $V1 == '1' ]; then
	echo "SFP-2E1-ToP"
	FILE_UPDATE="firmware_update_sfp_2E1_top"
fi


if [ -f "$FMDIR/firmware_update_sfp_1E1_top.tag.gz" ]; then
	echo "SFP-1E1-ToP"
	FILE_UPDATE="firmware_update_sfp_1E1_top"
fi

if [ -f "$FMDIR/firmware_update_sfp_1E2_top.tag.gz" ]; then
	echo "SFP-2E1-ToP"
	FILE_UPDATE="firmware_update_sfp_2E1_top"
fi



if ! [ -d "$FMDIR" ]; then
    mkdir $FMDIR
fi

if [ -f "$FMDIR/$FILE_UPDATE.tar.gz" ] ; then

# Firmware Update
echo "==FIRMWARE_UPDATE==:Begin"

    echo "==FIRMWARE_UPDATE==:Try to update firmware"

    /tmp/wait_print &

    echo $(gzip -d    $FMDIR/$FILE_UPDATE.tar.gz  2>&1) > /tmp/GZIP_RES
    echo $(tar -xf    $FMDIR/$FILE_UPDATE.tar -C $FMDIR  2>&1) > /tmp/TAR_RES

    chmod +rwx $FMDIR/*

    if [ -f "$FMDIR/sfp_update.sh" ] ; then
	rm $FMDIR/sfp_update.sh
    fi

    if [ -f "$FMDIR/$FILE_UPDATE.tar.gz" ] ; then
	rm $FMDIR/$FILE_UPDATE.tar.gz
    fi

    if [ -f "$FMDIR/$FILE_UPDATE.tar" ] ; then
	rm $FMDIR/$FILE_UPDATE.tar

	if [[ -d "$FMDIR" && "$(ls -A $FMDIR)" ]] ; then
		cp -f -r $FMDIR/* $DSTDIR1
		cp -f -r $FMDIR/mnt/* $DSTDIR2 > /dev/null 2>&1

		if [ -f $FMDIR/busybox ] ; then
			rm /bin/busybox
			cp $FMDIR/busybox /bin
		fi

	fi

	if [ -f "$FMDIR/$RBF" ] ; then
		echo "CRITICAL SECTION: BEGIN"

		echo "==FIRMWARE_UPDATE==:CRITICAL SECTION:Update Kernel"
		/root/update_kernel.sh

		echo "==FIRMWARE_UPDATE==:CRITICAL SECTION:Update FPGA"
		/root/update_rbf.sh

		ISWAIT="true"

		echo "CRITICAL SECTION: END"
	fi

	echo "==FIRMWARE_UPDATE==:End"

    else

	echo "==FIRMWARE_UPDATE==:Failed:Can not process $FILE_UPDATE.tar.gz"

    fi

else
	echo "==FIRMWARE_UPDATE==:No file to update"
fi

cp /root/config /usr/bin/config

# Delete all files from firmware update folder
if [[ -d "$FMDIR" && "$(ls -A $FMDIR)" ]] ; then
    echo "==FIRMWARE_UPDATE==:Deleting files from firmware_update folder"
    rm  -r $FMDIR/*
fi

killall wait_print > /dev/null 2>&1

if [ $ISWAIT == "true" ] ; then

	echo "==FIRMWARE_UPDATE==:Command REBOOT"

	/root/stop

	echo "==FIRMWARE_UPDATE==:Wait for REBOOT"

	for d in `seq 1 1000`
	do
		echo "Wait...("$d")"
		sleep 1
	done

else

	echo "==FIRMWARE_UPDATE==:Finished - No reboot"

fi
